/*
    A basic extension of the java.awt.Frame class
 */

import java.awt.*;

public class CondProbFrame extends Frame {
	void LoadfromFIle_Action(Event event) {
       CP.LoadWeights();
	}

	void SavetoFile_Action(Event event) {
       CP.SaveWeights();
	}

	void InitParams_Action(Event event) {
        CP.initParameters();
	}

	void Stop_Action(Event event) {

        CP.suspend();
	}

	void DFrame_Action(Event event) {


		//{{CONNECTION
		// Create and show the Frame
		
		if (CP.DF == null ){ 
		  CP.DF = new DataFrame(); 
		}
		 CP.DF.show();
	//	(new DataFrame()).show();
		//}}
	}

	void Load_Action(Event event) {
        CP.GetPatterns();
	}

	void DataBase_Action(Event event) {
        CP.CreateDBFrame();
	}

	void Update_Action(Event event) {
        Update_parameters();
	}

	void ErrField_EnterHit(Event event) {
        try {
			      CP.ErrorFunc = (Double.valueOf( ErrField.getText())).doubleValue();
		    }catch(NumberFormatException e){
		         System.out.println("Error: String to Double");
		    }
	}

	public boolean action(Event event, Object arg) {
		if (event.target instanceof MenuItem) {
			String label = (String) arg;
			if (event.target == LoadfromFIle) {
				LoadfromFIle_Action(event);
				return true;
			} else
			if (event.target == SavetoFile) {
				SavetoFile_Action(event);
				return true;
			} else
			if (event.target == InitParams) {
				InitParams_Action(event);
				return true;
			} else
			if (event.target == Stop) {
				Stop_Action(event);
				return true;
			} else
			if (event.target == DFrame) {
				DFrame_Action(event);
				return true;
			} else
			if (event.target == LoadFromDB) {
				Load_Action(event);
				return true;
			} else
			if (event.target == DataBase) {
				DataBase_Action(event);
				return true;
			} else
			if (event.target == Update) {
				Update_Action(event);
				return true;
			} else
				if (event.target == Start) {
					Start_Action(event);
					return true;
				}
		}
		return super.action(event, arg);
	}

	void Start_Action(Event event) {
	       
	       ErrorVal.setText("---");
	       if (running){CP.resume();}
	       else{CP.start(); running =true;}     
	      
	     //  CP.LearnProb(Integer.parseInt(MaxLoopField.getText()));
	}

	void AlphaField_EnterHit(Event event) {
        try {
			      CP.alpha = (Double.valueOf(AlphaField.getText())).doubleValue();
		    }catch(NumberFormatException e){
		         System.out.println("Error: String to Double");
		    }
	}

	void EtaField_EnterHit(Event event) {
	    try {
			      CP.eta = (Double.valueOf(EtaField.getText())).doubleValue();
		    }catch(NumberFormatException e){
		         System.out.println("Error: String to Double");
		    }
     }
  
    void Update_parameters() {
       NName.setText((CP.node).name);
       InsizeVal.setText(Integer.toString(CP.insize));
	   OutsizeVal.setText(Integer.toString(CP.outsize));
	   EtaField.setText(Double.toString(CP.eta));
	   AlphaField.setText(Double.toString(CP.alpha));
	   NodeType.setText(Integer.toString((CP.node).Type));
	   MaxField.setText(Integer.toString(CP.npatterns));
	   ErrField.setText(Double.toString(CP.ErrorFunc));
    }

	public CondProbFrame() {

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 401,insets().top + insets().bottom + 447);
		CondProbPanel = new java.awt.Panel();
		CondProbPanel.setLayout(null);
		CondProbPanel.reshape(insets().left + 12,insets().top + 36,384,408);
		add(CondProbPanel);
		labelCondProb = new java.awt.Label("CondProb");
		labelCondProb.reshape(12,0,84,25);
		labelCondProb.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelCondProb);
		labelOutsize = new java.awt.Label("Outsize:",Label.RIGHT);
		labelOutsize.reshape(60,120,48,25);
		labelOutsize.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelOutsize);
		labelInside = new java.awt.Label("Insize:",Label.RIGHT);
		labelInside.reshape(60,96,48,25);
		labelInside.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelInside);
		InsizeVal = new java.awt.Label("---",Label.RIGHT);
		InsizeVal.reshape(120,96,48,25);
		InsizeVal.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(InsizeVal);
		OutsizeVal = new java.awt.Label("---",Label.RIGHT);
		OutsizeVal.reshape(120,120,48,25);
		OutsizeVal.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(OutsizeVal);
		labelParameter = new java.awt.Label("Learning Parameter");
		labelParameter.reshape(12,156,144,24);
		labelParameter.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelParameter);
		labelETA = new java.awt.Label("eta:",Label.RIGHT);
		labelETA.reshape(48,180,48,36);
		labelETA.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelETA);
		labelError = new java.awt.Label("Error:",Label.RIGHT);
		labelError.reshape(204,288,60,36);
		labelError.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelError);
		EtaField = new java.awt.TextField();
		EtaField.setText("0");
		EtaField.reshape(108,180,84,36);
		EtaField.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(EtaField);
		ErrorVal = new java.awt.Label("0.0",Label.RIGHT);
		ErrorVal.reshape(276,288,84,36);
		ErrorVal.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(ErrorVal);
		AlphaField = new java.awt.TextField();
		AlphaField.setText("0");
		AlphaField.reshape(108,216,84,36);
		AlphaField.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(AlphaField);
		ErrField = new java.awt.TextField();
		ErrField.setText("0");
		ErrField.reshape(108,312,84,36);
		ErrField.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(ErrField);
		labelMAX = new java.awt.Label("MaxPattern:",Label.RIGHT);
		labelMAX.reshape(12,276,84,36);
		labelMAX.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelMAX);
		label1 = new java.awt.Label("MaxLoop:");
		label1.reshape(204,180,72,36);
		label1.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(label1);
		MaxLoopField = new java.awt.TextField();
		MaxLoopField.setText("0");
		MaxLoopField.reshape(276,180,84,36);
		MaxLoopField.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(MaxLoopField);
		labelNodeType = new java.awt.Label("Node Type:",Label.RIGHT);
		labelNodeType.reshape(24,60,84,25);
		labelNodeType.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelNodeType);
		labelNodeName = new java.awt.Label("Node Name:",Label.RIGHT);
		labelNodeName.reshape(24,36,84,25);
		labelNodeName.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelNodeName);
		NName = new java.awt.Label("---");
		NName.reshape(120,36,252,25);
		NName.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(NName);
		NodeType = new java.awt.Label("---",Label.RIGHT);
		NodeType.reshape(120,60,48,25);
		NodeType.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(NodeType);
		MaxField = new java.awt.TextField();
		MaxField.setText("0");
		MaxField.reshape(108,276,84,36);
		MaxField.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(MaxField);
		labelALPHA = new java.awt.Label("alpha",Label.RIGHT);
		labelALPHA.reshape(48,216,48,36);
		labelALPHA.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelALPHA);
		labelErrFunc = new java.awt.Label("ErrorFunc:",Label.RIGHT);
		labelErrFunc.reshape(24,312,72,36);
		labelErrFunc.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelErrFunc);
		labelCount = new java.awt.Label("0",Label.RIGHT);
		labelCount.reshape(252,372,105,33);
		labelCount.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(labelCount);
		label2 = new java.awt.Label("Loop Count:",Label.RIGHT);
		label2.reshape(108,372,145,31);
		label2.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(label2);
		ErrorAve = new java.awt.Label("0.0",Label.RIGHT);
		ErrorAve.reshape(276,324,84,36);
		ErrorAve.setFont(new Font("Dialog", Font.PLAIN, 14));
		CondProbPanel.add(ErrorAve);
		setTitle("Untitled");
		//}}

		//{{INIT_MENUS
		ManuBar = new java.awt.MenuBar();

		File = new java.awt.Menu("File");
		DataBase = new java.awt.MenuItem("DataBase...");
		File.add(DataBase);
		LoadFromDB = new java.awt.MenuItem("Load from DB");
		File.add(LoadFromDB);
		SavetoFile = new java.awt.MenuItem("Save to File");
		File.add(SavetoFile);
		LoadfromFIle = new java.awt.MenuItem("Load from File");
		File.add(LoadfromFIle);
		ManuBar.add(File);

		Learning = new java.awt.Menu("Learning");
		Start = new java.awt.MenuItem("Start");
		Learning.add(Start);
		Stop = new java.awt.MenuItem("Stop");
		Learning.add(Stop);
		Learning.addSeparator();
		InitParams = new java.awt.MenuItem("Init Parameters");
		Learning.add(InitParams);
		ManuBar.add(Learning);

		Window = new java.awt.Menu("Window");
		Update = new java.awt.MenuItem("Update");
		Window.add(Update);
		DFrame = new java.awt.MenuItem("Create DataFrame");
		Window.add(DFrame);
		ManuBar.add(Window);
		setMenuBar(ManuBar);
		//$$ ManuBar.move(0,0);
		//}}
	}

	public CondProbFrame(String title) {
	    this();
	    setTitle(title);
	}
	
	public CondProbFrame(CondProb cp) {
	    this();
	    CP = cp;
	}

    public synchronized void show() {
    	move(50, 50);
    	super.show();
    }

	public boolean handleEvent(Event event) {
    	if (event.id == Event.WINDOW_DESTROY) {
            hide();         // hide the Frame
            return true;
    	}
		if (event.target == EtaField && event.id == Event.ACTION_EVENT) {
			EtaField_EnterHit(event);
			return true;
		}
		if (event.target == AlphaField && event.id == Event.ACTION_EVENT) {
			AlphaField_EnterHit(event);
			return true;
		}
		if (event.target == ErrField && event.id == Event.ACTION_EVENT) {
			ErrField_EnterHit(event);
			return true;
		}
		
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	java.awt.Panel CondProbPanel;
	java.awt.Label labelCondProb;
	java.awt.Label labelOutsize;
	java.awt.Label labelInside;
	java.awt.Label InsizeVal;
	java.awt.Label OutsizeVal;
	java.awt.Label labelParameter;
	java.awt.Label labelETA;
	java.awt.Label labelError;
	java.awt.TextField EtaField;
	java.awt.Label ErrorVal;
	java.awt.TextField AlphaField;
	java.awt.TextField ErrField;
	java.awt.Label labelMAX;
	java.awt.Label label1;
	java.awt.TextField MaxLoopField;
	java.awt.Label labelNodeType;
	java.awt.Label labelNodeName;
	java.awt.Label NName;
	java.awt.Label NodeType;
	java.awt.TextField MaxField;
	java.awt.Label labelALPHA;
	java.awt.Label labelErrFunc;
	java.awt.Label labelCount;
	java.awt.Label label2;
	java.awt.Label ErrorAve;
	//}}

	//{{DECLARE_MENUS
	java.awt.MenuBar ManuBar;
	java.awt.Menu File;
	java.awt.MenuItem DataBase;
	java.awt.MenuItem LoadFromDB;
	java.awt.MenuItem SavetoFile;
	java.awt.MenuItem LoadfromFIle;
	java.awt.Menu Learning;
	java.awt.MenuItem Start;
	java.awt.MenuItem Stop;
	java.awt.MenuItem InitParams;
	java.awt.Menu Window;
	java.awt.MenuItem Update;
	java.awt.MenuItem DFrame;
	//}}
	CondProb CP;
	double eta,alpha, error, errorfunc;
	int insize, outsize,maxpattern;
	boolean running=false;
}
