import java.util.*;
import symjava.sql.*;

public class DataBase {
    String url;
    String usr, pwd, db_host; 
    String driver;

    Connection conn = null;

    String TABLES="";
    int table_no;
    public static String OUTPUT; //  output collumn name
    // Time difference between tokyo and other city
    int td; 

    Vector num[] = new Vector[1];

    public DataBase(){
	num[0] = new Vector();
	 }

    public DataBase(String t){ 
	this();
	setTables(t);
    }
    
    public void setTables(String t){
	 TABLES = t;
	 table_no = (new StringTokenizer(t)).countTokens();
    }

    public void appendTable(String t){
	 TABLES = TABLES + " " + t;
	 table_no = (new StringTokenizer(TABLES)).countTokens();
    }

    public void showTables(){
	 System.out.println("TABLES=\"" +TABLES+"\"");
    }

//  get Result vector method after initialize(td, OUTPUT, TABLES)
    public void getData(Vector r[], int mode){
	access(r, mkSelect(OUTPUT,mode), mkFrom(TABLES), mkWhere(td,mode));
    }
    public void getData(String s, Vector r[],int mode){
	access(r, mkSelect(s, mode), mkFrom(TABLES), mkWhere(td,mode));
    }
    /*
    public void getData(String s, int TimeDeley, Vector r[],int mode){
	access(r, mkSelect(s,mode), mkFrom(TABLES), mkWhere(TimeDeley,mode));
    }

    public void getSQLData(String s, Vector r[],mode){
	access(r, s, mkFrom(TABLES), mkWhere(td));
    }
*/
////////////////////////////////////////////////////////////////////////////
// Connect DataBase at url with usr, pwd by driver.

    public void connect(String Host, String User, String Passwd){
        db_host= Host;
        usr = User;
	    pwd = Passwd;
	    url = "jdbc:dbaw://"+db_host+":8889/Oracle_7/TNS:rwc/ORCL/ORCL";
	    driver = "symantec.itools.db.jdbc.Driver";
	    
	    connect();
    }
    
    public void connect(){
        // DataBase ؤ³
        try {
            Class.forName(driver);
        } catch(ClassNotFoundException ex) {
            System.err.println("ERROR: Could not find the specified JDBC Driver");
            ex.printStackTrace();
         //   System.exit(1);
        }

        try {
            conn = DriverManager.getConnection(url, usr, pwd);
        } catch(SQLException ex) {
            System.err.println("ERROR: Could not open DB connection.");
            ex.printStackTrace();
        //    System.exit(1);
        }
    }

    public void close(){
	try{ conn.close(); } catch(SQLException ex) { }
	System.exit(1);
    }

// internal methods
    public String mkSelect(String o, int mode){
	int i;
	StringBuffer s = new StringBuffer();

	for(i=0; i< table_no; i++){
	   if(i>0) { 
	     s.append(", "); s.append("a"+i+"."+o+" ");
	   }else {
	     if (mode > 0) { s.append("a0."+o+ "+24 ");}else{ s.append("a0."+o+ " ");}
	   }
	}
	return(s.toString());
    }
    public String mkFrom(String t){
	StringTokenizer s;
	StringBuffer sb;
	int i,j;
	s = new StringTokenizer(t); sb = new StringBuffer();
	j = s.countTokens();
	for(i = 0; i < j; i++){
	    if(i > 0) sb.append(", ");
	    sb.append(s.nextToken()+" a"+i);
	}
	return(sb.toString());
    }

    public String mkWhere(int t, int mode){
	StringBuffer s;
	int i;

	s = new StringBuffer("( ");
	for(i = 1; i<table_no; i++){
	    if(i > 1){
		s.append(" and ");
	    }
	    if (mode > 0){
	       s.append(" a0.DAY=a"+i+".DAY and a0.MONTH=a"+i+".MONTH"
	       +" and a0.RAINSTART is not null and a"+i+".RAINSTART is not null"
	//       +" and a0.RAINSTART  < a"+i+".RAINSTART"
	       );
	    }else{
	       s.append(" a0.DAY=a"+i+".DAY+1 and a0.MONTH=a"+i+".MONTH"
	       +" and a0.RAINSTART is not null and a"+i+".RAINSTART is not null"  
	       +" and a0.RAINSTART > a"+i+".RAINSTART");
	        
	    }
//       // Old 
//	       "a0.HOUR = (a"+i+".HOUR + "+t+")"
//	       +" and a0.DAY=a"+i+".DAY and a0.MONTH = a"+i+".MONTH"
	   
	}
// In the case that Date at Other city is yesterday of Tokyo, Julius day is used.
/*
	s.append(" ) or ( ");
	for(i = 1; i<table_no; i++){
	    if(i > 1){
		s.append(" and ");
	    }
	   s.append("to_number(to_char(to_date(to_char(a0.DAY)||'-'||to_char(a0.MONTH)||'-'||'1995', 'DD-MM-YYYY'),'J')) = to_number(to_char(to_date(to_char(a"+i+".DAY)||'-'||to_char(a"+i+".MONTH)||'-'||'1995', 'DD-MM-YYYY'),'J'))+1"
	   + " and a0.HOUR+24 = (a"+i+".HOUR + "+t+")");
	}
	*/
	s.append(")");
	return(s.toString());
    }

    public void access(Vector X[], String destinations, String tables, String conditions){
        int j, dest_no;
	Statement stmt = null;
        ResultSet rs = null;

	dest_no = (new StringTokenizer(destinations,", ")).countTokens();
        // μ¹Ԥȷ̤μ
        try {
            stmt = conn.createStatement();
           System.out.println("SELECT  "+destinations+
		" FROM "+tables+" WHERE " + conditions);
            rs = stmt.executeQuery("SELECT  "+destinations+
		" FROM "+tables+" WHERE " + conditions);
        } catch (SQLException ex) {
            System.err.println("ERROR: Could not execute the specified SQL statement.");
            ex.printStackTrace();
            System.exit(1);
        }
        // 
        try {
            while (rs.next()) {
		for(j=1; j<= dest_no; j++){
			if("-".equals(rs.getString(j))){
				X[j-1].addElement("0.0");
			}else{
				X[j-1].addElement(rs.getString(j));
			}
		}
		
            }
        } catch (SQLException ex) {
            System.err.println("ERROR: Could not get result value.");
            ex.printStackTrace();
            System.exit(1);
        }
    }
/*
// main() of Sample program ////////////////////////////////////////////////
    public static void main(String[] arg) {
        int i, j, n;
// Make DataBase class and initialize at first.
	DataBase db = new DataBase();
	db.setTables("t662 t670"); 
	db.appendTable("t622"); 
	db.OUTPUT = "KOUSUI";
	db.td = 5;

// Prepare stored classes.
	Vector number[] = new Vector[1];
	Vector result[] = new Vector[db.table_no];

	number[0] = new Vector();
	for(i = 0; i< db.table_no; i++){
		result[i] = new Vector();
	}

// Connect to Oracle DataBase through dbAnywhere on surint3 (or rwcpc2?)
	db.db_host="rwcpc2";
	db.url = "jdbc:dbaw://"+db.db_host+":8889/Oracle_7/TNS:rwc/ORCL/ORCL";
	db.usr = "sysman"; db.pwd = "sysman"; 
	db.driver = "symantec.itools.db.jdbc.Driver";

	db.connect();

	db.getSQLData("count(*)", number);
	n = Integer.parseInt((String)number[0].elementAt(0));
	System.out.println(Integer.toString(n));

// Getting result body	
//	db.getData(result);
	db.getData("KOUSUI", result);

// How to access results
	for(i=0; i< result[0].size() ; i++){
	   for(j = 0; j < db.table_no; j++){
		System.out.print(result[j].elementAt(i)+":");
	   }
	   System.out.println("");
	}
	try{ db.conn.close(); } catch(SQLException ex) { }
	System.exit(1);
    }
// end of main(); 
*/

}
