/*
    A basic extension of the java.awt.Frame class
 */
import java.util.*;
import java.awt.*;

public class DataBaseFrame extends Frame {
	void DisconnectButton_Clicked(Event event) {
        if (DB.conn != null){
            DB.close();
	        DBPanel.enable();
		    ConnectDB.setLabel("Connect to DataBase");
	        DatasetPanel.enable();
	        }
	    else { System.out.println(" Database is already disconnected.");}
        
		//{{CONNECTION
		// Enable the Panel
		
		//}}
	}

	void buttonShowData_Clicked(Event event) {

		//{{CONNECTION
		// Create and show the Frame
		
		if (DataArea == null ){
		    DataArea = new DataFrame();
	    }
		DataArea.show();
		DataArea.setData(result, DB.table_no);
		//}}
	}

	void DSetField_EnterHit(Event event) {
        DB.OUTPUT = DSetField.getText();
	}
    
	void InputTblField_EnterHit(Event event) {
        DB.setTables(InputTblField.getText());
	}

	void OutputTblField_EnterHit(Event event) {
        DB.appendTable(OutputTblField.getText()); 
	}

	void LoadData_Clicked(Event event) {
	    int i,n;
	    
	    label_N_DSet.setText("Please wait...");
	   
	    DB.setTables(OutputTblField.getText()); 
	    DB.appendTable(InputTblField.getText());
	    
	    result = new Vector[DB.table_no];

	    for(i = 0; i< DB.table_no; i++){
		    result[i] = new Vector();
	    }

        DB.getData(DSetField.getText(),result,0);
        n = result[0].size();

		//{{CONNECTION
		// Set the text for Label...
		label_N_DSet.setText(Integer.toString(n));
		//}}
	}
	
	public void setData(Vector V[],int mode) {
	    int i,n;
	    
	    label_N_DSet.setText("Please wait...");
	    DB.setTables(OutputTblField.getText()); 
	    DB.appendTable(InputTblField.getText());
	    
     //   DB.getData(DSetField.getText(), Integer.parseInt(DelayField.getText()), V);
        DB.getData(DSetField.getText(), V, mode);
        n = V[0].size();
        
        label_N_DSet.setText(Integer.toString(n));

	}

	void ConnectDB_Clicked(Event event) {
	    
        ConnectDataBase();
	}

    public void ConnectDataBase(){
         
        if (DB == null){
	        DB = new DataBase();
	    }
	    if (DB.conn == null){
            DB.db_host= HostField.getText();
            DB.usr = UserField.getText();
	        DB.pwd = PasswdField.getText();
	        DB.url = "jdbc:dbaw://"+DB.db_host+":8889/Oracle_7/TNS:rwc/ORCL/ORCL";
	        DB.driver = "symantec.itools.db.jdbc.Driver";
	   
		    DB.connect();
		 }else{
		    HostField.setText(DB.db_host);
            UserField.setText(DB.usr);
	        PasswdField.setText(DB.pwd);
		 }
		//{{CONNECTION
		// Enable the Panel
	   if (DB.conn != null){
	        ConnectDB.setLabel("Connected");
	        DBPanel.disable();        
	        DatasetPanel.enable(); }
	    else { System.out.println("Cannot Connect Database");}
		//}}
      }	
	 public DataBaseFrame() {

		//{{INIT_CONTROLS
		setLayout(null);
		addNotify();
		resize(insets().left + insets().right + 482,insets().top + insets().bottom + 440);
		DBPanel = new java.awt.Panel();
		DBPanel.setLayout(null);
		DBPanel.reshape(insets().left + 12,insets().top + 12,468,144);
		DBPanel.setFont(new Font("Dialog", Font.BOLD, 14));
		add(DBPanel);
		label_DB = new java.awt.Label("DataBase");
		label_DB.reshape(12,0,84,36);
		label_DB.setFont(new Font("Dialog", Font.PLAIN, 14));
		DBPanel.add(label_DB);
		ConnectDB = new java.awt.Button("Connect to DataBase");
		ConnectDB.reshape(108,0,192,36);
		ConnectDB.setFont(new Font("Dialog", Font.PLAIN, 14));
		DBPanel.add(ConnectDB);
		HostField = new java.awt.TextField();
		HostField.setText("rwcpc8");
		HostField.reshape(120,36,144,36);
		HostField.setFont(new Font("Dialog", Font.PLAIN, 14));
		DBPanel.add(HostField);
		labelUser = new java.awt.Label("User:",Label.RIGHT);
		labelUser.reshape(12,72,96,36);
		labelUser.setFont(new Font("Dialog", Font.PLAIN, 14));
		DBPanel.add(labelUser);
		labelPasswd = new java.awt.Label("Passwd:",Label.RIGHT);
		labelPasswd.reshape(12,108,96,36);
		labelPasswd.setFont(new Font("Dialog", Font.PLAIN, 14));
		DBPanel.add(labelPasswd);
		PasswdField = new java.awt.TextField();
		PasswdField.setText("sysman");
		PasswdField.reshape(120,108,144,36);
		PasswdField.setFont(new Font("Dialog", Font.PLAIN, 14));
		DBPanel.add(PasswdField);
		UserField = new java.awt.TextField();
		UserField.setText("sysman");
		UserField.reshape(120,72,144,36);
		UserField.setFont(new Font("Dialog", Font.PLAIN, 14));
		DBPanel.add(UserField);
		label_host = new java.awt.Label("Host Name:",Label.RIGHT);
		label_host.reshape(0,36,108,36);
		label_host.setFont(new Font("Dialog", Font.PLAIN, 14));
		DBPanel.add(label_host);
		DatasetPanel = new java.awt.Panel();
		DatasetPanel.setLayout(null);
		DatasetPanel.reshape(insets().left + 12,insets().top + 156,468,276);
		DatasetPanel.setFont(new Font("Dialog", Font.PLAIN, 14));
		add(DatasetPanel);
		DatasetPanel.disable();
		DataSet = new java.awt.Label("Data Set Name:",Label.RIGHT);
		DataSet.reshape(0,84,132,36);
		DatasetPanel.add(DataSet);
		DSetField = new java.awt.TextField();
		DSetField.setText("KOUSUI");
		DSetField.reshape(132,84,205,36);
		DatasetPanel.add(DSetField);
		LoadData = new java.awt.Button("Load Data");
		LoadData.reshape(336,120,111,36);
		DatasetPanel.add(LoadData);
		labelInput = new java.awt.Label("Input Tables:",Label.RIGHT);
		labelInput.reshape(24,48,108,36);
		DatasetPanel.add(labelInput);
		InputTblField = new java.awt.TextField();
		InputTblField.setText("t640 t641");
		InputTblField.reshape(132,48,205,36);
		DatasetPanel.add(InputTblField);
		labelOutput = new java.awt.Label("Output Tables:",Label.RIGHT);
		labelOutput.reshape(12,12,120,36);
		DatasetPanel.add(labelOutput);
		OutputTblField = new java.awt.TextField();
		OutputTblField.setText("t662");
		OutputTblField.reshape(132,12,205,36);
		DatasetPanel.add(OutputTblField);
		label_NDSet = new java.awt.Label("N of Data Set:",Label.RIGHT);
		label_NDSet.reshape(12,180,132,36);
		DatasetPanel.add(label_NDSet);
		label_N_DSet = new java.awt.Label("0");
		label_N_DSet.reshape(168,180,108,36);
		DatasetPanel.add(label_N_DSet);
		buttonShowData = new java.awt.Button("Data Frame");
		buttonShowData.reshape(12,228,138,33);
		DatasetPanel.add(buttonShowData);
		labelDelay = new java.awt.Label("Delay:",Label.RIGHT);
		labelDelay.reshape(0,120,132,36);
		DatasetPanel.add(labelDelay);
		DelayField = new java.awt.TextField();
		DelayField.setText("5");
		DelayField.reshape(132,120,205,36);
		DatasetPanel.add(DelayField);
		DisconnectButton = new java.awt.Button("Disconnect");
		DisconnectButton.reshape(276,228,154,40);
		DatasetPanel.add(DisconnectButton);
		setTitle("Untitled");
		//}}

		//{{INIT_MENUS
		//}}
	//	DB = new DataBase();
	}

	public DataBaseFrame(String title) {
	    this();
	    setTitle(title);
	}

	public DataBaseFrame(DataBase D) {
	    this();
	   DB = D;
	}
	
	public synchronized void show() {
    	move(50, 50);
    	super.show();
    }

	public boolean handleEvent(Event event) {
    	if (event.id == Event.WINDOW_DESTROY) {
            hide();         // hide the Frame
            DB.close();
            return true;
    	}
		if (event.target == ConnectDB && event.id == Event.ACTION_EVENT) {
			ConnectDB_Clicked(event);
			return true;
		}
		if (event.target == LoadData && event.id == Event.ACTION_EVENT) {
			LoadData_Clicked(event);
			return true;
		}
		if (event.target == OutputTblField && event.id == Event.ACTION_EVENT) {
			OutputTblField_EnterHit(event);
			return true;
		}
		if (event.target == InputTblField && event.id == Event.ACTION_EVENT) {
			InputTblField_EnterHit(event);
			return true;
		}
		if (event.target == DSetField && event.id == Event.ACTION_EVENT) {
			DSetField_EnterHit(event);
			return true;
		}
		if (event.target == buttonShowData && event.id == Event.ACTION_EVENT) {
			buttonShowData_Clicked(event);
			return true;
		}
		if (event.target == DisconnectButton && event.id == Event.ACTION_EVENT) {
			DisconnectButton_Clicked(event);
			return true;
		}
		return super.handleEvent(event);
	}

	//{{DECLARE_CONTROLS
	java.awt.Panel DBPanel;
	java.awt.Label label_DB;
	java.awt.Button ConnectDB;
	java.awt.TextField HostField;
	java.awt.Label labelUser;
	java.awt.Label labelPasswd;
	java.awt.TextField PasswdField;
	java.awt.TextField UserField;
	java.awt.Label label_host;
	java.awt.Panel DatasetPanel;
	java.awt.Label DataSet;
	java.awt.TextField DSetField;
	java.awt.Button LoadData;
	java.awt.Label labelInput;
	java.awt.TextField InputTblField;
	java.awt.Label labelOutput;
	java.awt.TextField OutputTblField;
	java.awt.Label label_NDSet;
	java.awt.Label label_N_DSet;
	java.awt.Button buttonShowData;
	java.awt.Label labelDelay;
	java.awt.TextField DelayField;
	java.awt.Button DisconnectButton;
	//}}

	//{{DECLARE_MENUS
	//}}
	// Local Def
	DataBase DB;
	Vector result[];
	DataFrame DataArea;

}